class Agent {
  PVector position;
  float size; 
  color c;
  String letter;
  int trial_index;
  
  float[][] features;
  // each feature will be a parameter that drives phenotype of the agent
  // each sensor (containing 24 feature values) is ?????
  
  Agent(String letter, int trial_index) {
    features = new float[NUM_SENSORS][NUM_FEATURES];
    position = new PVector(random(0, width/2), random(0, height/2), random(0, 500));
    size = 5; // what should size be mapped to?? 
    this.letter = letter;
    this.trial_index = trial_index;
    
    c = color(map((int(letter.charAt(0)) - 65),0, 25, 0, 255),  // map hue to which letter it is
              map(trial_index, 1, 40, 50, 255), // map trial number to how saturated the color is
              255); // brightness value = max
  }
  
  void printGenotype() {
    println("Agent: " + letter + " Trial: " + trial_index); 
    for (int i = 0; i < NUM_SENSORS; i++) {
      println("sensor number " + (i+1));
      for (int j = 0; j < NUM_FEATURES; j++) {
        print(features[i][j] + " ");
      }
      println();
    }
    println("-----------------------------");
  }
  
  void display() {
    fill(c); 
    ellipse(position.x, position.y, 5, 5);
  }
  
  void move() {
    
    
  }
  
}
